<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;


use App\Http\Base\BaseController;
use App\Http\Controllers\Providers\IAM\Core\AuthManager\WorkerAuth;
use App\Http\Controllers\Providers\IAM\Core\AuthManager\AuthTrait;
use App\Http\Controllers\Providers\IAM\Core\AuthManager\PasswordHashes;
use App\Http\Models\UsersModel;
use App\Http\Services\AdministratoradministratorService;
use App\Http\Services\UsersService;
use Illuminate\Http\Request;


class AdministratorAuthController extends BaseController
{
    use AuthTrait;
    protected $validator, $baseService;

    public function __construct()
    {
        parent::__construct();
        $this->baseService = new UsersService();
    }

    public function login(Request $request)
    {
        if ($request->isMethod("GET")) {
            if (!empty(WorkerAuth::auth()->getAuth())) {
                return redirect("administrator/");
            }
            return view("modules.administratorauth.auth_login", $this->data);
        }
        $input = $request->all();
        $errMessage = WorkerAuth::auth()->authLogin($input);
        if (!empty(WorkerAuth::auth()->getAuth())) {
            return redirect("administrator/");
        } else {
            return redirect("administrator/login")->withInput()->with("errValidation", $errMessage);
        }
    }

    public function logout()
    {
        WorkerAuth::auth()->logout();
        return redirect("administrator/login");
    }

    public function profile(Request $request)
    {
        if ($request->isMethod("GET")) {
            $this->data["users"] = $this->baseService->show(WorkerAuth::getAuth()->id);
            return view("modules.administratorauth.auth_profile", $this->data);
        }
        $input = $request->all();
        if (empty($input["password"])) {
            array_pull($input, "password");
        } else {
            $input["password"] = PasswordHashes::hashingPassword($input["password"]);
        }
        $this->baseService->update(WorkerAuth::auth()->getAuth()->id, $input);
        return redirect()->back()->with("successMessage", "Data has been updated");
    }

    public function recovery(Request $request)
    {
        if ($request->isMethod("GET")) {
            return view("modules.administratorauth.recovery_password", $this->data);
        }
        $input = $request->all();
        $model = $this->baseService->show(["administratoradministrator.email" => $input["email"]]);
        $password = random_bytes(10);
        $input["password"] = PasswordHashes::hashingPassword($password);
        $this->baseService->update($model->id, $input);
        WorkerAuth::auth()->forgotPassword($model, $password);
        return redirect("administrator/login")->with("successMessages", 'Email Recovery already sended. ' .
            '<br/>Please Login with new Password !');
    }
}